#if defined(__has_include) && __has_include(<any>)
#include <any>
#include <iostream>
#include <string_view>
#include <vector>

#include <cstdlib>
#include <cxxabi.h>
#include <memory>

struct A { };
struct B : A { };

int main() {
    std::vector< std::any > vec;

    vec.emplace_back( 42 );
    vec.emplace_back( 3.14 );
    vec.emplace_back( "hi" );
    vec.emplace_back( std::string( "string" ) );
    vec.emplace_back( B() );

    for ( auto &v : vec ) {
        std::cout << "element of type " << v.type().name() << std::endl;
        if ( auto *i = std::any_cast< int >( &v ) )
            std::cout << "int value is " << *i << std::endl;
        if ( auto *a = std::any_cast< A >( &v ) )
            std::cout << "A value" << std::endl; // not triggered
    }
}

#else
#error <any> not available, use a recent compiler with a recent std library
#endif
