#include <cstring>
#include <memory>

template< auto fn >
struct FnDeleter {
	template< typename T >
	void operator()(T* ptr) {
		fn(ptr);
	}
};

int main() {
	std::unique_ptr< char[], FnDeleter< std::free > >
		ptr{ strdup("Hello") };
}
