#include <iostream>
#include <memory>

struct NVBase {
	~NVBase() { std::cout << "NVBase dtor (non-virtual)\n"; }
};

struct VBase {
	virtual ~VBase() { std::cout << "VBase dtor (virtual)\n"; }
};

struct NVDerived : NVBase {
	~NVDerived() { std::cout << "NVDerived dtor (non-virtual)\n"; }
};

struct VDerived : VBase {
	~VDerived() override { std::cout << "VDerived dtor (virtual)\n"; }
};

int main() {
	{
		std::cout << "unique_ptr:\n";
		std::unique_ptr< VBase > v_ptr{ new VDerived() };
		std::unique_ptr< NVBase > nv_ptr{ new NVDerived() };
	}
	{
		std::cout << "shared_ptr:\n";
		std::shared_ptr< VBase > v_ptr{ new VDerived() };
		std::shared_ptr< NVBase > nv_ptr{ new NVDerived() };
	}
}
