#include <iostream>
#include <string>
#include <stdexcept>
#include <regex>

using IpField = unsigned int;
using IpAddress =
    std::tuple< IpField, IpField, IpField, IpField >;

IpAddress readIp( const std::string& s ) {
    std::regex r("([0-9]{1,3})\\.([0-9]{1,3})\\."
                 "([0-9]{1,3})\\.([0-9]{1,3})");
    std::smatch match;

    if ( !std::regex_match( s, match, r ) || match.size() != 5 ) {
        throw std::runtime_error( "Invalid address" );
    }

    return std::make_tuple( stoi( match[ 1 ].str() ),
                            stoi( match[ 2 ].str() ),
                            stoi( match[ 3 ].str() ),
                            stoi( match[ 4 ].str() ) );
}

int main() {
    auto ip = readIp( "192.168.1.16" );
    std::cout << std::get< 0 >(ip) << "."
              << std::get< 1 >(ip) << "."
              << std::get< 2 >(ip) << "."
              << std::get< 3 >(ip) << "\n";
}
