#include <iostream>
#include <memory>
#include <string>

struct Person {
	std::string name;
	int age;

	Person(std::string name, int age)
	    : name(std::move(name))
	    , age(age) {}

	~Person() {
		std::cout << "~Person\n";
	}
};

int main() {
	std::shared_ptr<std::string> string_ptr;
	{
		auto person = std::make_shared<Person>("John Cleese", 79);
		string_ptr = std::shared_ptr<std::string>(
			person, &person->name);
	}
	std::cout << *string_ptr << '\n';
}
